#include <stdio.h>
#include <gb.h>

// TEhhCo
#include "snd_drv.c"
// TEhf[^
#include "snd_data.c"

// ^Cf[^
#include "bird_bg.c"
#include "bird_spr.c"
#include "bird_cloud.c"

#define GAMEMODE_INIT    0U
#define GAMEMODE_TITLE   2U
#define GAMEMODE_PLAY    3U
#define GAMEMODE_END     4U

#define SPR_HERO         0U
#define SPR_STR          2U
#define SPR_MAX         40U

#define HERO_ACT_NONE    0U
#define HERO_ACT_START   1U
#define HERO_ACT_MOVE    2U
#define HERO_ACT_MISS    3U
#define HERO_ACT_DOWN    4U
#define HERO_ACT_END     5U

#define HERO_XPOS       40U
#define HERO_YPOS       64U

UBYTE intcnt;// JE^
UBYTE first;// t@[XgtO
UBYTE game_mode;// Q[[h
UBYTE input_on, input_old, input_edge, input_trg;// L[͗p
fixed seed;// V[h
UBYTE scrx,scry;// XN[pXYW
UBYTE wscrx, wscry;// XN[pXYW
UWORD score;// XRA
UWORD sco_chk;// XRA`FbNp
UWORD cloud;// _Ajp
BYTE fade_cnt, fade_dir;
UBYTE start;//X^[g
UBYTE pipe_y;//yǂ̍
UBYTE pipe_x;//yǂ̐ݒuʒu
UBYTE pipe_cnt;//yǂ̐ݒuJE^
unsigned char bgbuf[5];// BGf[^擾p
BYTE scoreTiles[22];

// vCp\
struct st_hero {
	UBYTE act; // ANVno
	UBYTE x;   // XW
	UBYTE y;   // YW
	BYTE yadd; // YZl
} hero;

void hero_ctrl();
void pipe_set();
void sprite_init();

// BGMNGXg
void sndreq_bgm(UBYTE req_bgm)
{
	// BGMĐ
	snd_req_bgm(snd_bgm_adr[req_bgm][0],snd_bgm_adr[req_bgm][1],snd_bgm_adr[req_bgm][2],snd_bgm_adr[req_bgm][3]);
}

// S.E.NGXg
void sndreq_se(UBYTE req_se)
{
	// SEĐ
	snd_req_se(snd_se_adr[req_se], snd_se_atr[req_se][0], snd_se_atr[req_se][1]);
}


// wi
void init_bg()
{
	UBYTE i, j;
	// 
	for (j = 1U; j != 14U; j++) {
		for (i = 0U; i != 32U; i++) {
			gotoxy(i, j);
			setchar(0U);
		}
	}
	// _()
	for (i = 0U; i != 32U; i += 4U) {
		for (j = 0U; j != 4U; j++) {
			gotoxy(i+j, 13U);
			setchar(4U+j);
		}
	}
	// _()ƒn()
	for (i = 0U; i != 32U; i++) {
		gotoxy(i, 14U);
		setchar(1U);
		gotoxy(i, 16U);
		setchar(97U);
		gotoxy(i, 17U);
		setchar(1U);
		gotoxy(i, 0U);
		setchar(96U);
	}
	// n()
	for (i = 0U; i != 32U; i += 2U) {
		for (j = 0U; j != 2U; j++) {
			gotoxy(i+j, 15U);
			setchar(98U+j);
		}
	}
}

// _AjĎ~܂Ă悤Ɍ
void cloud_set()
{

	UBYTE i;
	UWORD w;
	cloud = (UWORD)(scrx & 0x07U);
	cloud <<= 6;
	for (i = 0U; i != 4U; i++) {
		w = (UWORD)(scrx >> 3);
		w = (4U - w + i) & 0x03U;
		set_bkg_data(4U+i, 1U, &bird_cloud[cloud+(w<<4)]); // BGAj
	}

}

// EChEɃXRA\
void disp_score()
{
	UBYTE i, f, x;
	WORD tmp1, tmp2, tmp3;
	for (i = 0U; i != 20U; i++) {
		scoreTiles[i] = 0x20;
	}

	// 2sڂ͋󔒂Ŗ߂
	set_win_tiles( 0, 1, 20, 1, (void *)scoreTiles);

	// 1sڂSCORE\
	scoreTiles[5] = 0x53;//S
	scoreTiles[6] = 0x43;//C
	scoreTiles[7] = 0x4f;//O
	scoreTiles[8] = 0x52;//R
	scoreTiles[9] = 0x45;//E
	// ꉞ4܂ŕ\
	tmp1 = 1000;
	f = 0;
	x = 0;
	tmp3 = score;
	for (i = 0U; i != 4U; i++) {
		tmp2 = tmp3 / tmp1;
		tmp2 %= 10U;
		if (i == 3U) {
			f = 1U;
		}
		if (tmp2 != 0 || f == 1U) {
			scoreTiles[11+x] = (BYTE)(tmp2 + 0x30);
			f = 1;
			x++;
		}
		tmp1 /= 10;
	}
	// 1sڂZbg
	set_win_tiles( 0U, 0U, 20U, 1U, (void *)scoreTiles);
}

// ^Cg
void init_title()
{
	UBYTE i;
	DISPLAY_OFF;// ʑŜ\
	HIDE_WIN;// WIN\
	HIDE_BKG;// BG\
	HIDE_SPRITES;// XvCg\
	sprite_init();// XvCgW
	init_bg();
	fade_cnt = 0x00;
	fade_dir = 2;
	scrx = scry = 0U;
	wscrx = wscry = 0U;
	// ^CgXvCgŕ\
	for (i = 0U; i != 7U; i++) {
		set_sprite_tile( i+SPR_STR, 12U+(i<<1));
		set_sprite_prop( i+SPR_STR, S_PALETTE);
		move_sprite( i+SPR_STR, 60U+(i<<3), 48U);// XvCg̍Wݒ
	}

	sndreq_bgm(SND_BGM_MUTE);// BGMĐ

	SHOW_SPRITES;// XvCg\
	SHOW_BKG;// BG\
	DISPLAY_ON;// ʑŜ\
}

void proc_title()
{
	UBYTE i;
	BYTE wave[] = {0,-1,-2,-1,0,1,2,1};
	// ͑҂
	if ((input_trg & (J_START + J_A)) && fade_cnt == 0x30) {
		fade_dir = -2;
		seed.b.l = DIV_REG;
		seed.b.h = DIV_REG;
		initrand(seed.w);// 
	}
	if (fade_dir == 0 && fade_cnt == 0) {
		game_mode = GAMEMODE_PLAY;// Q[
		first = 0U;// t@[XgtO
	}
	// Aj
	for (i = SPR_HERO; i != (SPR_HERO + 2U); i++) {
		set_sprite_tile( i, ((intcnt >> 1) & 4U)+(i<<1));
		set_sprite_prop( i, S_PALETTE);
		move_sprite( i, 80U+(i<<3), 72U+wave[(intcnt >> 2) & 0x07U]);// XvCg̍Wݒ
	}
	scrx++;
	cloud_set();
}

// vC
void init_game()
{
	UBYTE i;
	DISPLAY_OFF;// ʑŜ\
	HIDE_WIN;// WIN\
	HIDE_BKG;// BG\
	HIDE_SPRITES;// XvCg\
	sprite_init();// XvCgW
	init_bg();
	fade_cnt = 0x00;
	fade_dir = 2;
	scrx = scry = 0U;
	// GET READYXvCgŕ\
	for (i = 0U; i != 7U; i++) {
		set_sprite_tile( i+SPR_STR, 26U+(i<<1));
		set_sprite_prop( i+SPR_STR, S_PALETTE);
		move_sprite( i+SPR_STR, 60U+(i<<3), 48U);// XvCg̍Wݒ
	}

	SHOW_SPRITES;// XvCg\
	SHOW_BKG;// BG\
	DISPLAY_ON;// ʑŜ\

	score = 0U;
	sco_chk = 0U;
	start = 0U;
	hero.act = HERO_ACT_START;
	hero.x = HERO_XPOS;
	hero.y = HERO_YPOS;
	hero.yadd = 0;
	disp_score();
	wscrx = 7U;
	wscry = 132U;
	SHOW_WIN;// WIN\

	sndreq_bgm(SND_BGM_PLAY);// BGMĐ
}
void proc_game()
{
	UBYTE i;
	if (hero.act == HERO_ACT_START) {
		if (scrx > 32U) {
			scrx -= 32U;
		}
	}
	// ͑҂
	if (hero.act == HERO_ACT_START && (input_trg & (J_START + J_A))) {
		// GET READY
		for (i = 0U; i != 7U; i++) {
			move_sprite( i+SPR_STR, 0U, 0U);// XvCg̍Wݒ
		}
		hero.act = HERO_ACT_MOVE;
	}
	if (hero.act == HERO_ACT_MOVE) {
		// Jn҂
		if (start == 0U) {
			if (scrx == 32U) {
				start = 1U;
				pipe_x = 25U;
				pipe_cnt = 0U;
			}
		}
		// JnyǂZbg
		if (start == 1U) {
			pipe_set();
		}
	}
	hero_ctrl();
	if (hero.act <= HERO_ACT_MOVE) {
		scrx++;
		cloud_set();
	}
}

// yǂZbg
void pipe_set()
{
	UBYTE i;
	UBYTE py[] = {2U,3U,4U,2U,3U,4U,2U,4U};

	// 8hbgXN[ɏs
	if ((scrx & 0x07U) == 0U) {
		if (pipe_cnt == 0U) {
			pipe_y = py[(rand() & 0x07U)];
		}
		// yǂ̒[(Ɖ)
		if (pipe_cnt == 0U || pipe_cnt == 5U) {
			// 
			for (i = 1U; i != pipe_y; i++) {
				gotoxy(pipe_x, i);
				setchar(0U);
			}
			// ̓yǂ̉
			gotoxy(pipe_x, pipe_y);
			setchar(pipe_cnt == 0U ? 2U : 3U);
			gotoxy(pipe_x, pipe_y+1U);
			setchar(pipe_cnt == 0U ? 2U : 3U);
			// 
			for (i = 0U; i != 5U; i++) {
				gotoxy(pipe_x, i+pipe_y+2U);
				setchar(0U);
			}
			// ̓yǂ̉
			gotoxy(pipe_x, pipe_y+7U);
			setchar(pipe_cnt == 0U ? 2U : 3U);
			gotoxy(pipe_x, pipe_y+8);
			setchar(pipe_cnt == 0U ? 2U : 3U);
			// 
			for (i = pipe_y+1U; i <= 4U; i++) {
				gotoxy(pipe_x, i+8U);
				setchar(0U);
			}
		}
		if (pipe_cnt >= 1U && pipe_cnt <= 4U) {
			// ̓y
			for (i = 1U; i < pipe_y-1U; i++) {
				gotoxy(pipe_x, i);
				setchar(111U+pipe_cnt);
			}
			gotoxy(pipe_x, pipe_y-1U);
			setchar(115U+pipe_cnt);
			gotoxy(pipe_x, pipe_y);
			setchar(119U+pipe_cnt);
			gotoxy(pipe_x, pipe_y+1);
			setchar(123U+pipe_cnt);
			// 
			for (i = 0U; i != 5U; i++) {
				gotoxy(pipe_x, i+pipe_y+2U);
				setchar(0U);
			}
			// ̓y
			gotoxy(pipe_x, pipe_y+7U);
			setchar(99U+pipe_cnt);
			gotoxy(pipe_x, pipe_y+8U);
			setchar(103U+pipe_cnt);
			gotoxy(pipe_x, pipe_y+9U);
			setchar(107U+pipe_cnt);
			for (i = pipe_y; i <= 4U; i++) {
				gotoxy(pipe_x, i+10U);
				setchar(111U+pipe_cnt);
			}
		}
	}
	if ((scrx & 0x07U) == 7U) {
		if (++pipe_cnt >= 16U) {
			pipe_cnt = 0U;
		}
		if (++pipe_x >= 32U) {
			pipe_x = 0U;
		}
	}
}

// vC[̃Rg[ƕ\
void hero_ctrl()
{
	UBYTE i, ani, sx, sy;// BGp
	// ړ
	if (hero.act == HERO_ACT_MOVE) {
		if ((intcnt & 3U) == 0U) {
			hero.yadd++;
		}
		if (input_trg & J_A) {
			hero.yadd = -4;
			sndreq_se(SND_SE_FLAP);// H΂S.E.Đ
		}
		hero.y += (UBYTE)(hero.yadd >> 1);
	}
	// ~Xė
	if (hero.act == HERO_ACT_DOWN && hero.y >= 115U) {
		if (input_trg & (J_START + J_A)) {
			hero.act = HERO_ACT_END;
			fade_dir = -2;
		}
	}
	// tF[hIŏn߂
	if (hero.act == HERO_ACT_END) {
		if (fade_dir == 0 && fade_cnt == 0) {
			game_mode = GAMEMODE_PLAY;// Q[
			first = 0U;// t@[XgtO
		}
	}

	ani = 0U;
	if (hero.act == HERO_ACT_START) {
		ani = (intcnt >> 1) & 0x04U;
	}
	if (hero.act == HERO_ACT_MOVE) {
		// yǂnʂƂ̓蔻
		sx = ((hero.x-2U+scrx) >> 3) & 0x1f;
		sy = ((hero.y-4U+scry) >> 3) & 0x1f;
		get_bkg_tiles(sx,sy,2,2, bgbuf);// BG̃f[^擾
		for (i = 0U; i != 4U; i++) {
			if (bgbuf[i] >= 0x60U) {
				hero.act = HERO_ACT_MISS;
				sco_chk = 0U;
				sndreq_bgm(SND_BGM_MUTE);// BGMĐ
				sndreq_se(SND_SE_MISS);// ~XS.E.Đ
				break;
			}
		}
		if (hero.yadd > 0) {
			ani = 4U;
		}
		// yǒʉ߃`FbN
		sx = ((hero.x+8U+scrx) >> 3) & 0x1f;
		sy = ((118U+scry) >> 3) & 0x1f;
		get_bkg_tiles(sx,sy,1U,1U, bgbuf);// BG̃f[^擾
		if (bgbuf[0] == 0x73U && sco_chk == 0U) {
			score++;
			disp_score();
			sco_chk = 8U;
		}
		if (sco_chk > 0U) {
			sco_chk--;
		}
	}
	// ̂Œ~
	if (hero.act == HERO_ACT_MISS) {
		sco_chk++;
		if (sco_chk == 45U) {
			hero.act = HERO_ACT_DOWN;
			sco_chk = 0U;
			sndreq_se(SND_SE_FALL);// S.E.Đ
			// GAME OVERXvCgŕ\
			for (i = 0U; i != 7U; i++) {
				set_sprite_tile( i+SPR_STR, 40U+(i<<1));
				set_sprite_prop( i+SPR_STR, S_PALETTE);
				move_sprite( i+SPR_STR, 60U+(i<<3), 48U);// XvCg̍Wݒ
			}
		}
	}
	// Ă
	if (hero.act == HERO_ACT_DOWN) {
		if (hero.y < 115U) {
			hero.y += 2U;
		}
	}
	// 
	set_sprite_tile( SPR_HERO, ani);
	set_sprite_prop( SPR_HERO, S_PALETTE);
	move_sprite( SPR_HERO, hero.x, hero.y+8U);
	// E
	set_sprite_tile( SPR_HERO+1U, ani+2U);
	set_sprite_prop( SPR_HERO+1U, S_PALETTE);
	move_sprite( SPR_HERO+1U, hero.x+8U, hero.y+8U);
}

// game_modȅit@[Xgj
void init()
{
	if (first == 0U) {
		switch (game_mode) {
			case GAMEMODE_INIT:
				game_mode = GAMEMODE_TITLE;// ^Cg
			case GAMEMODE_TITLE:
				init_title();
				break;
			case GAMEMODE_PLAY:
				init_game();
				break;
		}
		first = 1U;
	}
}

// game_modȅ
void proc()
{
	snd_driver();
	switch (game_mode) {
		case GAMEMODE_INIT:
			break;
		case GAMEMODE_TITLE:
			proc_title();
			break;
		case GAMEMODE_PLAY:
			proc_game();
			break;
	}
	intcnt++;
}

// XvCgW
void sprite_init()
{
	UBYTE i;
	for (i = 0U; i != SPR_MAX; i++) {
		set_sprite_tile( i, 0U);
		move_sprite( i, 0U, 0U);
		set_sprite_prop( i, 0U);
	}
}

// ʂ̃tF[h
void fade_ctrl()
{
	UBYTE grade = 255U;
	if (fade_dir != 0) {
		fade_cnt += fade_dir;
		if (fade_cnt == 0x00 || fade_cnt == 0x30) {
			fade_dir = 0;
		}
		switch(fade_cnt)
		{
			case 0x00:
			case 0x01:
			case 0x02:
				BGP_REG = OBP0_REG = 0x00U; // ^
				OBP1_REG = 0x00U;
				break;
			case 0x10:
				BGP_REG = OBP0_REG = 0x54U;
				OBP1_REG = 0x50U;
				break;
			case 0x20:
				BGP_REG = OBP0_REG = 0xA4U;
				OBP1_REG = 0xA0U;
				break;
			case 0x2E:
			case 0x2F:
			case 0x30:
				BGP_REG = OBP0_REG = 0xE4U; // ʏ
				OBP1_REG = 0xE0U;
				break;
		}
	}
}

// VBLŌĂ΂
void vbl_isr(void)
{
	// L[
	input_old = input_on;
	input_on = joypad();
	input_edge = input_on ^ input_old;
	input_trg = input_on & input_edge;
	// [hʃt@[Xg
	init();
	// [hʎs
	proc();
	// BG̕`JnXYWݒ
	move_bkg(scrx, scry);
	move_win(wscrx, wscry);
	// ʃtF[h
	fade_ctrl();
}

// C
void main()
{
	DISPLAY_OFF;// ʑŜ\
	HIDE_WIN;// WIN\
	HIDE_BKG;// BG\
	HIDE_SPRITES;// XvCg\

	// Iɉʂ^ɂ
	fade_cnt = 0x01;
	fade_dir = -1;
	fade_ctrl();

	print(" ");// _~[

	SPRITES_8x16;// XvCg[h8*16ɐݒ
	set_bkg_data(0U, 128U, bird_bg);// ^Cf[^BGƂĐݒ
	set_bkg_data(128U, 128U, bird_bg);// ^Cf[^BGƂĐݒ
	set_sprite_data(0U, 128U, bird_spr); // ^Cf[^XvCgƂĐݒ

	disable_interrupts();// 
	add_VBL(vbl_isr);// VBLɒǉ
	enable_interrupts();// L
	set_interrupts(VBL_IFLAG);// VBLZbg

	snd_reg_init();// TEhWX^
	snd_track_init();// TEhgbN

	// C[viĂǂǉƂȂj
	while(1) {
		delay(1000UL);
	}
}
